

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>shyft.dashboard.apps.dtss_viewer.dtsc_helper_functions &mdash; Documentation</title>
  

  
  
    <link rel="shortcut icon" href="../../../../../_static/favicon.ico"/>
  
  
  

  
  <script type="text/javascript" src="../../../../../_static/js/modernizr.min.js"></script>
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../../../../../" src="../../../../../_static/documentation_options.js"></script>
        <script src="../../../../../_static/jquery.js"></script>
        <script src="../../../../../_static/underscore.js"></script>
        <script src="../../../../../_static/doctools.js"></script>
        <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
        <script src="../../../../../_static/js/bootstrap.min.js"></script>
        <script src="../../../../../_static/js/bootstrap.bundle.min.js"></script>
        <script src="../../../../../_static/js/custom.js"></script>
    
    <script type="text/javascript" src="../../../../../_static/js/theme.js"></script>

    

  
  <link rel="stylesheet" href="../../../../../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../../../../_static/pygments.css" type="text/css" />
  <link rel="stylesheet" href="../../../../../_static/css/bootstrap.min.css" type="text/css" />
  <link rel="stylesheet" href="../../../../../_static/css/bootstrap-grid.min.css" type="text/css" />
  <link rel="stylesheet" href="../../../../../_static/css/custom.css" type="text/css" />
    <link rel="index" title="Index" href="../../../../../genindex.html" />
    <link rel="search" title="Search" href="../../../../../search.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../../../../../index.html" class="icon icon-home"> Shyft
          

          
          </a>

          
            
            
              <div class="version">
                4.12
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <p class="caption"><span class="caption-text">Project</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../../../content/project/what_is_shyft.html">What is Shyft?</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../../content/project/get_involved.html">Get involved</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../../content/project/contact.html">Contact</a></li>
</ul>
<p class="caption"><span class="caption-text">Time Series</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../../../content/time_series/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../../content/time_series/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../../content/time_series/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../../content/time_series/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Hydrology</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../../../content/hydrology/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../../content/hydrology/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../../content/hydrology/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../../content/hydrology/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Energy Market</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../../../content/energy_market/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../../content/energy_market/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../../content/energy_market/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../../content/energy_market/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Dashboard</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../../../content/dashboard/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../../content/dashboard/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../../content/dashboard/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../../content/dashboard/api.html">API Documentation</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../../../index.html">Shyft</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../../../../index.html">Docs</a> &raquo;</li>
        
          <li><a href="../../../../index.html">Module code</a> &raquo;</li>
        
      <li>shyft.dashboard.apps.dtss_viewer.dtsc_helper_functions</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <h1>Source code for shyft.dashboard.apps.dtss_viewer.dtsc_helper_functions</h1><div class="highlight"><pre>
<span></span><span class="kn">from</span> <span class="nn">typing</span> <span class="kn">import</span> <span class="n">List</span><span class="p">,</span> <span class="n">Tuple</span>
<span class="kn">import</span> <span class="nn">shyft.time_series</span> <span class="k">as</span> <span class="nn">sa</span>
<span class="kn">from</span> <span class="nn">shyft.dashboard.time_series.state</span> <span class="kn">import</span> <span class="n">Quantity</span><span class="p">,</span> <span class="n">State</span><span class="p">,</span> <span class="n">Unit</span>
<span class="kn">from</span> <span class="nn">shyft.dashboard.time_series.sources.ts_adapter</span> <span class="kn">import</span> <span class="n">TsAdapter</span>
<span class="kn">from</span> <span class="nn">shyft.dashboard.time_series.state</span> <span class="kn">import</span> <span class="n">State</span>


<div class="viewcode-block" id="check_dtss_url"><a class="viewcode-back" href="../../../../../content/dashboard/api.html#shyft.dashboard.apps.dtss_viewer.dtsc_helper_functions.check_dtss_url">[docs]</a><span class="k">def</span> <span class="nf">check_dtss_url</span><span class="p">(</span><span class="n">dtss_url</span><span class="p">:</span> <span class="nb">str</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">bool</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    This function evaluates if the url belogs to a running dts server</span>
<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    dtss_url:</span>
<span class="sd">        url of dtss like localhost:20000</span>

<span class="sd">    Returns</span>
<span class="sd">    -------</span>
<span class="sd">    True if dtss reachable with given url, False if not</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">dtsc</span> <span class="o">=</span> <span class="n">sa</span><span class="o">.</span><span class="n">DtsClient</span><span class="p">(</span><span class="n">dtss_url</span><span class="p">)</span>
    <span class="k">try</span><span class="p">:</span>
        <span class="n">dtsc</span><span class="o">.</span><span class="n">reopen</span><span class="p">()</span>
    <span class="k">except</span> <span class="ne">RuntimeError</span> <span class="k">as</span> <span class="n">e</span><span class="p">:</span>
        <span class="k">return</span> <span class="kc">False</span>
    <span class="k">finally</span><span class="p">:</span>
        <span class="n">dtsc</span><span class="o">.</span><span class="n">close</span><span class="p">()</span>
    <span class="k">return</span> <span class="kc">True</span></div>


<div class="viewcode-block" id="try_dtss_connection"><a class="viewcode-back" href="../../../../../content/dashboard/api.html#shyft.dashboard.apps.dtss_viewer.dtsc_helper_functions.try_dtss_connection">[docs]</a><span class="k">def</span> <span class="nf">try_dtss_connection</span><span class="p">(</span><span class="n">dtss_url</span><span class="p">:</span> <span class="nb">str</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">bool</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    This function evaluates if the url belogs to a running dts server</span>
<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    dtss_url:</span>
<span class="sd">        url of dtss like localhost:20000</span>

<span class="sd">    Returns</span>
<span class="sd">    -------</span>
<span class="sd">    True if dtss reachable with given url</span>

<span class="sd">    Raises</span>
<span class="sd">    ------</span>
<span class="sd">    RuntimeError if no dtss can be found under given url</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">dtsc</span> <span class="o">=</span> <span class="n">sa</span><span class="o">.</span><span class="n">DtsClient</span><span class="p">(</span><span class="n">dtss_url</span><span class="p">)</span>
    <span class="k">try</span><span class="p">:</span>
        <span class="n">dtsc</span><span class="o">.</span><span class="n">reopen</span><span class="p">()</span>
    <span class="k">finally</span><span class="p">:</span>
        <span class="n">dtsc</span><span class="o">.</span><span class="n">close</span><span class="p">()</span>
    <span class="k">return</span> <span class="kc">True</span></div>


<div class="viewcode-block" id="find_all_dtss_infos"><a class="viewcode-back" href="../../../../../content/dashboard/api.html#shyft.dashboard.apps.dtss_viewer.dtsc_helper_functions.find_all_dtss_infos">[docs]</a><span class="k">def</span> <span class="nf">find_all_dtss_infos</span><span class="p">(</span><span class="n">dtss_url</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">dtss_container</span><span class="p">:</span><span class="nb">str</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">sa</span><span class="o">.</span><span class="n">TsVector</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    This function returns a TsVector of TsInfo for each Time Series in the container of the</span>
<span class="sd">    dtss at the url.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    dtss_url:</span>
<span class="sd">        url to dtss</span>
<span class="sd">    dtss_container:</span>
<span class="sd">        dtss data container to search in</span>

<span class="sd">    Returns</span>
<span class="sd">    -------</span>
<span class="sd">    a TsVector of TsInfo for each Time Series</span>

<span class="sd">    Raises</span>
<span class="sd">    ------</span>
<span class="sd">    RuntimeError if no dtss can be found under given url</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">dtsc</span> <span class="o">=</span> <span class="n">sa</span><span class="o">.</span><span class="n">DtsClient</span><span class="p">(</span><span class="n">dtss_url</span><span class="p">)</span>
    <span class="k">try</span><span class="p">:</span>
        <span class="k">return</span> <span class="n">dtsc</span><span class="o">.</span><span class="n">find</span><span class="p">(</span><span class="n">sa</span><span class="o">.</span><span class="n">shyft_url</span><span class="p">(</span><span class="n">dtss_container</span><span class="p">,</span><span class="sa">r</span><span class="s1">&#39;.*&#39;</span><span class="p">))</span>
    <span class="k">finally</span><span class="p">:</span>
        <span class="n">dtsc</span><span class="o">.</span><span class="n">close</span><span class="p">()</span></div>


<div class="viewcode-block" id="find_all_ts_names_and_url"><a class="viewcode-back" href="../../../../../content/dashboard/api.html#shyft.dashboard.apps.dtss_viewer.dtsc_helper_functions.find_all_ts_names_and_url">[docs]</a><span class="k">def</span> <span class="nf">find_all_ts_names_and_url</span><span class="p">(</span><span class="n">dtss_url</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">dtss_container</span><span class="p">:</span> <span class="nb">str</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">List</span><span class="p">[</span><span class="n">Tuple</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="nb">str</span><span class="p">]]:</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    This function returns a list of time series names and urls for each Time Series in the container of the</span>
<span class="sd">    dtss at the ts_url.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    dtss_url:</span>
<span class="sd">        url to dtss</span>
<span class="sd">    dtss_container:</span>
<span class="sd">        dtss data container to search in</span>

<span class="sd">    Returns</span>
<span class="sd">    -------</span>
<span class="sd">    List of Tuple with (ts_url, name) for each ts in the container</span>

<span class="sd">    Raises</span>
<span class="sd">    ------</span>
<span class="sd">    RuntimeError if no dtss can be found under given url</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">ts_infos</span> <span class="o">=</span> <span class="n">find_all_dtss_infos</span><span class="p">(</span><span class="n">dtss_url</span><span class="o">=</span><span class="n">dtss_url</span><span class="p">,</span> <span class="n">dtss_container</span><span class="o">=</span><span class="n">dtss_container</span><span class="p">)</span>
    <span class="k">return</span> <span class="p">[(</span><span class="n">sa</span><span class="o">.</span><span class="n">shyft_url</span><span class="p">(</span><span class="n">dtss_container</span><span class="p">,</span><span class="n">ti</span><span class="o">.</span><span class="n">name</span><span class="p">),</span> <span class="n">ti</span><span class="o">.</span><span class="n">name</span><span class="p">)</span> <span class="k">for</span> <span class="n">ti</span> <span class="ow">in</span> <span class="n">ts_infos</span><span class="p">]</span></div>


<div class="viewcode-block" id="DtssTsAdapter"><a class="viewcode-back" href="../../../../../content/dashboard/api.html#shyft.dashboard.apps.dtss_viewer.dtsc_helper_functions.DtssTsAdapter">[docs]</a><span class="k">class</span> <span class="nc">DtssTsAdapter</span><span class="p">(</span><span class="n">TsAdapter</span><span class="p">):</span>

    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">dtss_url</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">ts_url</span><span class="p">:</span> <span class="nb">str</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="kc">None</span><span class="p">:</span>
        <span class="nb">super</span><span class="p">()</span><span class="o">.</span><span class="fm">__init__</span><span class="p">()</span>
        <span class="c1"># TODO add unit reg</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">dtsc</span> <span class="o">=</span> <span class="n">sa</span><span class="o">.</span><span class="n">DtsClient</span><span class="p">(</span><span class="n">dtss_url</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">tsv_request</span> <span class="o">=</span> <span class="n">sa</span><span class="o">.</span><span class="n">TsVector</span><span class="p">([</span><span class="n">sa</span><span class="o">.</span><span class="n">TimeSeries</span><span class="p">(</span><span class="n">ts_url</span><span class="p">)])</span>

    <span class="k">def</span> <span class="fm">__call__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="p">,</span> <span class="n">time_axis</span><span class="p">:</span> <span class="n">sa</span><span class="o">.</span><span class="n">TimeAxis</span><span class="p">,</span> <span class="n">unit</span><span class="p">:</span> <span class="n">Unit</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Quantity</span><span class="p">[</span><span class="n">sa</span><span class="o">.</span><span class="n">TsVector</span><span class="p">]:</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">tsv</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">dtsc</span><span class="o">.</span><span class="n">evaluate</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">tsv_request</span><span class="o">.</span><span class="n">average</span><span class="p">(</span><span class="n">time_axis</span><span class="p">),</span> <span class="n">time_axis</span><span class="o">.</span><span class="n">total_period</span><span class="p">())</span>
        <span class="k">except</span> <span class="ne">RuntimeError</span> <span class="k">as</span> <span class="n">e</span><span class="p">:</span>
            <span class="k">return</span> <span class="n">sa</span><span class="o">.</span><span class="n">TsVector</span><span class="p">()</span>
        <span class="k">finally</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">dtsc</span><span class="o">.</span><span class="n">close</span><span class="p">()</span>
        <span class="k">return</span> <span class="n">State</span><span class="o">.</span><span class="n">Quantity</span><span class="p">(</span><span class="n">tsv</span><span class="p">,</span> <span class="s1">&#39;&#39;</span><span class="p">)</span></div>


<span class="k">if</span> <span class="vm">__name__</span> <span class="o">==</span> <span class="s1">&#39;__main__&#39;</span><span class="p">:</span>

    <span class="n">dtss_url</span> <span class="o">=</span> <span class="s1">&#39;localhost:20000&#39;</span>
    <span class="n">dtss_container</span> <span class="o">=</span> <span class="s1">&#39;test&#39;</span>


    <span class="n">check_dtss_url</span><span class="p">(</span><span class="n">dtss_url</span><span class="p">)</span>
    <span class="n">ts_url_names</span> <span class="o">=</span> <span class="n">find_all_ts_names_and_url</span><span class="p">(</span><span class="n">dtss_url</span><span class="o">=</span><span class="n">dtss_url</span><span class="p">,</span> <span class="n">dtss_container</span><span class="o">=</span><span class="n">dtss_container</span><span class="p">)</span>

    <span class="nb">print</span><span class="p">(</span><span class="n">ts_url_names</span><span class="p">[</span><span class="mi">0</span><span class="p">][</span><span class="mi">0</span><span class="p">])</span>
    <span class="n">dtss_adapter</span> <span class="o">=</span> <span class="n">DtssTsAdapter</span><span class="p">(</span><span class="n">dtss_url</span><span class="o">=</span><span class="n">dtss_url</span><span class="p">,</span> <span class="n">ts_url</span><span class="o">=</span><span class="n">ts_url_names</span><span class="p">[</span><span class="mi">0</span><span class="p">][</span><span class="mi">0</span><span class="p">])</span>

    <span class="n">time_axis</span> <span class="o">=</span> <span class="n">sa</span><span class="o">.</span><span class="n">TimeAxis</span><span class="p">(</span><span class="n">sa</span><span class="o">.</span><span class="n">utctime_now</span><span class="p">()</span><span class="o">-</span><span class="n">sa</span><span class="o">.</span><span class="n">Calendar</span><span class="o">.</span><span class="n">MONTH</span><span class="o">*</span><span class="mi">5</span><span class="p">,</span> <span class="mi">20</span><span class="p">,</span> <span class="n">sa</span><span class="o">.</span><span class="n">Calendar</span><span class="o">.</span><span class="n">DAY</span><span class="p">)</span>
    <span class="n">tsv</span> <span class="o">=</span> <span class="n">dtss_adapter</span><span class="p">(</span><span class="n">time_axis</span><span class="o">=</span><span class="n">time_axis</span><span class="p">,</span> <span class="n">unit</span><span class="o">=</span><span class="s1">&#39;&#39;</span><span class="p">)</span>
    <span class="nb">print</span><span class="p">(</span><span class="n">tsv</span><span class="o">.</span><span class="n">units</span><span class="p">)</span>
    <span class="nb">print</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">tsv</span><span class="p">))</span>
    <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">tsv</span><span class="p">):</span>
        <span class="nb">print</span><span class="p">(</span><span class="n">tsv</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">time_axis</span><span class="o">.</span><span class="n">time_points</span><span class="p">)</span>
        <span class="nb">print</span><span class="p">(</span><span class="n">tsv</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">values</span><span class="o">.</span><span class="n">to_numpy</span><span class="p">())</span>


    <span class="nb">print</span><span class="p">(</span><span class="n">ts_url_names</span><span class="p">[</span><span class="mi">1</span><span class="p">][</span><span class="mi">0</span><span class="p">])</span>
    <span class="n">dtss_adapter</span> <span class="o">=</span> <span class="n">DtssTsAdapter</span><span class="p">(</span><span class="n">dtss_url</span><span class="o">=</span><span class="n">dtss_url</span><span class="p">,</span> <span class="n">ts_url</span><span class="o">=</span><span class="n">ts_url_names</span><span class="p">[</span><span class="mi">1</span><span class="p">][</span><span class="mi">0</span><span class="p">])</span>

    <span class="n">time_axis</span> <span class="o">=</span> <span class="n">sa</span><span class="o">.</span><span class="n">TimeAxis</span><span class="p">(</span><span class="n">sa</span><span class="o">.</span><span class="n">utctime_now</span><span class="p">()</span><span class="o">-</span><span class="n">sa</span><span class="o">.</span><span class="n">Calendar</span><span class="o">.</span><span class="n">MONTH</span><span class="o">*</span><span class="mi">5</span><span class="p">,</span> <span class="mi">20</span><span class="p">,</span> <span class="n">sa</span><span class="o">.</span><span class="n">Calendar</span><span class="o">.</span><span class="n">DAY</span><span class="p">)</span>
    <span class="n">tsv</span> <span class="o">=</span> <span class="n">dtss_adapter</span><span class="p">(</span><span class="n">time_axis</span><span class="o">=</span><span class="n">time_axis</span><span class="p">,</span> <span class="n">unit</span><span class="o">=</span><span class="s1">&#39;&#39;</span><span class="p">)</span>
    <span class="nb">print</span><span class="p">(</span><span class="n">tsv</span><span class="o">.</span><span class="n">units</span><span class="p">)</span>
    <span class="nb">print</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">tsv</span><span class="p">))</span>
    <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">tsv</span><span class="p">):</span>
        <span class="nb">print</span><span class="p">(</span><span class="n">tsv</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">time_axis</span><span class="o">.</span><span class="n">time_points</span><span class="p">)</span>
        <span class="nb">print</span><span class="p">(</span><span class="n">tsv</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">values</span><span class="o">.</span><span class="n">to_numpy</span><span class="p">())</span>

</pre></div>

           </div>
           
          </div>
          <footer>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2021, The Shyft project

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/rtfd/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>